<script setup lang="ts">
import type { User } from '@/types/Employee'
import { ref, computed, onMounted } from 'vue'

const page = ref(1)
const itemsPerPage = ref<any>(8)
const search = ref<string>('')

const items = ref<User[]>([])

const headers = [
  {
    title: 'ID',
    key: 'id'
  },
  {
    title: 'Name',
    key: 'name'
  },
  {
    title: 'Position',
    key: 'role'
  },
  {
    title: 'Check In',
    key: 'timein'
  },
  {
    title: 'Check Out',
    key: 'timeout'
  },
  {
    title: 'Work Hours',
    key: 'timework'
  },

  { title: '', key: 'actions', sortable: false }
]

const pageCount = computed(() => {
  return Math.ceil(items.value.length / itemsPerPage.value)
})


onMounted(() => {
  initialize()
})



function initialize() {
  items.value = [
    {
      id: 1,
      name: 'Tanakit Wongviroj',
      gender: 'Male',
      tel: '088-888-8888',
      username: 'mark',
      password: 'mark',
      role: 'Manager',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 2,
      name: 'Sivat Ratanawong',
      gender: 'Male',
      tel: '088-888-8888',
      username: 'arm',
      password: 'arm',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 3,
      name: 'Kornnisa Thongiam',
      gender: 'Female',
      tel: '088-888-8888',
      username: 'cake',
      password: 'cake',
      role: 'Manager',
      timein: 'Sun Jan 14 2024 23:02:00 GMT+0700 (Indochina Time)',
      timeout: '',
      timework: 0
    },
    {
      id: 4,
      name: 'Supasita Pochawat',
      gender: 'Female',
      tel: '088-888-8888',
      username: 'john',
      password: 'john',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 5,
      name: 'Chanapa Pumthong',
      gender: 'Female',
      tel: '088-888-8888',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 6,
      name: 'Aphiwit Pluemchit',
      gender: 'Male',
      tel: '088-888-8888',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: 'Mon Jan 15 2024 07:57:45 GMT+0700 (Indochina Time)',
      timeout: '',
      timework: 0
    },
    {
      id: 7,
      name: 'Pimpisut Kaokritsadee',
      gender: 'Female',
      tel: '088-888-8888',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    },
    {
      id: 8,
      name: 'Tanapa Charoenjit',
      gender: 'Female',
      tel: '088-888-8888',
      username: 'jane',
      password: 'jane',
      role: 'Barista',
      timein: '',
      timeout: '',
      timework: 0
    }
  ]
}

onMounted(() => {
  initialize()
})

const formatteditems = computed(() => items.value.map((item) => ({ ...item })))

const filtereditems = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formatteditems.value.filter((item) =>
    item.name.toLowerCase().includes(searchLower)
  )
})

const submitPassword = (action: 'checkIn' | 'checkOut', index: number, item: User) => {
  if (index !== null) {
    if (action === 'checkIn') {
      // Check if the user has already checked in
      if (!item.timein) {
        const currentTime = new Date();
        item.timein = currentTime;
        items.value.splice(index, 1, { ...item });
        // alert('Check-in successful!');
      } else {
        // alert('Item has already checked in.');
      }
    } else if (action === 'checkOut') {
      // Check if the user has checked in before allowing check-out
      if (!item.timein) {
        // alert('Cannot check out. User has not checked in.');
      } else {
        item.timeout = new Date();

        const checkInTime = new Date(item.timein);
        const checkOutTime = new Date(item.timeout);

        if (!isNaN(checkInTime.getTime()) && !isNaN(checkOutTime.getTime())) {
          const hoursWorkedString = ((checkOutTime.getTime() - checkInTime.getTime()) / (1000 * 60 * 60)).toFixed(1);
          const hoursWorked = parseFloat(hoursWorkedString);
          item.timework = hoursWorked;

          items.value.splice(index, 1, { ...item });
          // alert('Check-out successful!');
        }
      }
    } else {
      console.error('Invalid action');
    }
  } else {
    console.error('Index not set');
  }
}


</script>

<template>
  <div>
    <!-- Data -->
    <div class="text-center">
      <h1 style="text-align: left">Working Attendance
      </h1>
    </div>

    <div>
      <!--title-->
      <v-card-title class="d-flex align-center pe-2">
        <v-icon icon="mdi mdi-account-clock"></v-icon> &nbsp; Working Hours
        <v-spacer></v-spacer>

        <!-- search -->
        <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line flat
          hide-details variant="solo-filled"></v-text-field>
      </v-card-title>

      <!-- table -->
      <div>
        <v-data-table v-model:page="page" :headers="headers" :items="filtereditems" :items-per-page="itemsPerPage">

          <template v-slot:bottom>
            <div class="text-center pt-2">
              <v-pagination v-model="page" :length="pageCount"></v-pagination>
            </div>
          </template>

          <template v-slot:[`item.actions`]="{ index, item }">
            <!-- Check IN Button -->
            <v-btn style="size: 5; background-color: rgb(75, 181, 67)" class="me-2"
              @click="() => submitPassword('checkIn', index, item)">
              <v-icon>mdi mdi-clock-in</v-icon>
            </v-btn>

            <!-- Check OUT Button -->
            <v-btn style="size: 5; background-color: #ff0000" @click="() => submitPassword('checkOut', index, item)">
              <v-icon>mdi mdi-clock-out</v-icon>
            </v-btn>
          </template>
        </v-data-table>
      </div>
    </div>
  </div>
</template>


<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

.v-btn {
  font-family: Verdana, sans-serif;
}

div {
  font-family: 'Kanit';
}
</style>
